var points = 0;
var totalRenders = 0;
var urlToImageMap = {};

function loadImageGroup(urls, onCompleteFunc) {
	var numImagesNotYetLoaded = urls.length;
	urlToImageMap = {};    
	var markLoaded = function() {
	    if (--numImagesNotYetLoaded == 0)
	        onCompleteFunc(urlToImageMap);
	}

	for (var i = 0; i < urls.length; i++) {
	    var img = new Image();
	    img.onload = markLoaded;
	    img.src = urls[i];
	    urlToImageMap[urls[i]] = img;
	}
}
function prePopulate(honeyCells){
    var honeyCells = JSON.parse(honeyCells);
    console.dir(honeyCells);
    var urls = [
		'images/neutral.png',
		'images/active.png',
		'images/touched.png',
		'images/unit.png',


	];

	loadImageGroup(urls, function(urlToImageMap) {
	//all are loaded. draw to canvas here
	   	document.getElementById("honeyComb").innerHTML="";
	    if( honeyCells.constructor === Array){
	        for (var i = 0; i < honeyCells.length; i++) {
	            populateHoneycomb( honeyCells[i], i );

	        };
	    }else{        
	        populateHoneycomb( honeyCells , 0);
	    }
	});

}



function populateHoneycomb( honeyCells , index){

	var height = "innerHeight" in window 
               ? window.innerHeight
               : document.documentElement.offsetHeight;
    var width = "innerWidth" in window 
               ? window.innerWidth
               : document.documentElement.offsetWidth;
    	
   	var cellWidth = width/(honeyCells.width);
   	var cellHeigth = (cellWidth / Math.sqrt(3))*2;
   	var canvas = document.createElement("canvas");
   	canvas.id = "canvas_"+index;
   	canvas.width = (honeyCells.width+1)*cellWidth;
   	var heightDifference = 0;
   	for( var i = 0; i < honeyCells.height; i++){
   	 	heightDifference = ((cellHeigth-(cellHeigth/2))/2)*i;
   	}
   	canvas.height = honeyCells.height*cellHeigth - heightDifference;	
   	document.getElementById("honeyComb").appendChild(canvas);

   	canvas.setAttribute("data-index", index); 

   	if( typeof honeyCells.score == "undefined"){
    	honeyCells.score = 0;
    }
   	canvas.setAttribute("data-score", honeyCells.score ); 
   	canvas.className += " canvasRendered";
   	if(index == 0){
   		canvas.className += " visible";
   		updateLabels(document.getElementById("canvas_0"));
   	}
   	var context = canvas.getContext('2d');  

    for (var i = 0; i < honeyCells.height; i++) {
    	var even = (i%2 == 0) ? true : false;
    	for (var j = 0; j < honeyCells.width; j++) {
    		var startx = (even) ?  j*cellWidth :  (j*cellWidth)+(cellWidth*0.5);
    		var starty = i*cellHeigth-((cellHeigth-(cellHeigth/2))/2)*i;
    		context.drawImage(urlToImageMap['images/neutral.png'], startx, starty , cellWidth, cellHeigth);    		
    	};
    };

    addDetails( honeyCells, cellWidth, cellHeigth, context );
   


}
function addDetails( honeyCells, cellWidth, cellHeigth, context ){

	setFilled( honeyCells, honeyCells.filled, "active" , cellWidth, cellHeigth, context);

    if(honeyCells.touched){
   		setFilled( honeyCells, honeyCells.touched, "touched" , cellWidth, cellHeigth, context);
    }
    if(honeyCells.unit){
    	setFilled( honeyCells, honeyCells.unit, "unit" , cellWidth, cellHeigth, context);
    	
    }
}

function setFilled( honeyCells, cellsToCheck, className, cellWidth, cellHeigth, context ){
		// honeyCells = jsonExample;

	for (var i =  0; i < cellsToCheck.length; i++) {
			var x = cellsToCheck[i].x;
			var y = cellsToCheck[i].y;
			var even = ( y % 2 == 0 ) ? true : false; 
			var startx = (even) ?  x*cellWidth :  (x*cellWidth)+(cellWidth*0.5);
    		var starty = y*cellHeigth-((cellHeigth-(cellHeigth/2))/2)*y;
    		context.drawImage(urlToImageMap['images/'+className+'.png'], startx, starty , cellWidth, cellHeigth);    		
		};	
}


function slideBack(){
	var actual = document.getElementById("honeyComb").getElementsByClassName("visible")[0];
	var actualId = actual.id.split("_")[1];
	if(actualId > 0){
		actualId--;
		actual.className = "canvasRendered";
		document.getElementById("canvas_"+actualId).className += " visible";
	}
	updateLabels(document.getElementById("canvas_"+actualId));
	
}
function updateLabels( e ){
	document.getElementById("score").innerHTML = e.getAttribute("data-score");
	document.getElementById("index").innerHTML = e.getAttribute("data-index");

}

function slideForward(){
	var actual = document.getElementById("honeyComb").getElementsByClassName("visible")[0];
	var actualId = actual.id.split("_")[1];
	if(actualId < document.getElementsByClassName("canvasRendered").length - 1){
		actualId++;
		
	}else{
		actualId = 0;
	}
	actual.className = " canvasRendered";
	document.getElementById("canvas_"+actualId).className += " visible";
	updateLabels(document.getElementById("canvas_"+actualId));
}
function slidePlay(){
	var play = document.getElementById("playSlide");

	if( play.getAttribute("data-intervalId") == "-1"){
		var intervalID = setInterval( function(){
			slideForward();
		}, 50);
		play.setAttribute('data-intervalId', intervalID);	
	}else{
		var intervalID = play.getAttribute("data-intervalId");
		clearInterval( intervalID );
		play.setAttribute('data-intervalId', "-1");	

	}
}
function hasClass(el, cls) {
  return el.className && new RegExp("(\\s|^)" + cls + "(\\s|$)").test(el.className);
}
function removeClass(ele,cls) {
    if (hasClass(ele,cls)) {
        var reg = new RegExp('(\\s|^)'+cls+'(\\s|$)');
        ele.className=ele.className.replace(reg,' ');
    }
}
function removeId(id) {
    return (elem=document.getElementById(id)).parentNode.removeChild(elem);
}

function toggleLeaderBoard(){
	var leaderBoard = document.getElementById("leaderBoard");
	if( hasClass(leaderBoard, "open")){
		removeClass(leaderBoard, "open");
	}else{
		leaderBoard.className += " open";
	}
	updateLeaderBoard()
}
function populateBoard(){
			var listBoard = document.getElementById("listBoard");
			var results = "";
			var rankings = data.data.rankings;
			var date = new Date();
			var seconds = date.getSeconds();
			var minutes = date.getMinutes();
			var hour = date.getHours(); 

			for (var i = rankings.length - 1; i >= 0; i--) {
				if( rankings[i].teamId == 235 ){

					results += "<p>Updated "+hour+"h "+minutes+"m "+seconds+"s</p>";
					results += "<h1>Cazziammolla Placement: "+rankings[i].rank+"</h1>";
					results += "<h2>with a score of: "+rankings[i].score+"</h2>";
					if (rankings[i].rank != points && points != 0){
						ringTheBell();
					}
					points = rankings[i].rank;

				}
			};

			var settings = data.data.settings;
			for (var i = 0; i < settings.length; i++) {
				for (var j = settings[i].rankings.length - 1; j >= 0; j--) {
					if(settings[i].rankings[j].teamId == 235){
						results += "<tr><td>"+i+"</td><td>"+j+"</td></tr>"
					}
				};
			};
			var results = "<table><thead><th>Setting</th><th>Placement</th></thead>"+results+"</table>";
			listBoard.innerHTML = results;


}
function updateLeaderBoard(){
	loadRankingJs('https://davar.icfpcontest.org/rankings.js?cachebuster='+ new Date().getTime());

	var intervalID = setInterval( function(){
		loadRankingJs('https://davar.icfpcontest.org/rankings.js?cachebuster='+ new Date().getTime());
	}, 30000);
	console.dir(intervalID);
}
function loadRankingJs(scriptName) {
	var rankingScript = document.getElementById("rankingScript");
	if ( rankingScript ){
		removeId("rankingScript");
	}
	var docHeadObj = document.getElementsByTagName("head")[0];
	var dynamicScript = document.createElement("script");
	dynamicScript.type = "text/javascript";
	dynamicScript.id = "rankingScript";
	dynamicScript.src = scriptName;
	dynamicScript.onload = function(){ populateBoard();};
	docHeadObj.appendChild(dynamicScript);

	return dynamicScript;
}

function ringTheBell(){
	document.getElementById("bell").play();
}

document.onkeydown = checkKey;

function sendJson(){
	// console.log("sending mama some json.")
	// socket.emit("jsonToParse", document.getElementById("sendHCJson").value);
	prePopulate( document.getElementById("sendHCJson").value);
}

function checkKey(e) {

    e = e || window.event;

	    if (e.keyCode == '37') {
	       slideBack();
	    }else if(e.keyCode == '39') {
	       slideForward();
	    }
	
}
// jsonExample = {"height":15,"width":15,"sourceSeeds":[0],"units":[{"members":[{"x":0,"y":0}],"pivot":{"x":0,"y":0}}],"id":1,"filled":[{"x":2,"y":4},{"x":3,"y":4},{"x":4,"y":4},{"x":5,"y":4},{"x":6,"y":4},{"x":11,"y":4},{"x":2,"y":5},{"x":8,"y":5},{"x":11,"y":5},{"x":2,"y":6},{"x":11,"y":6},{"x":2,"y":7},{"x":3,"y":7},{"x":4,"y":7},{"x":8,"y":7},{"x":11,"y":7},{"x":2,"y":8},{"x":9,"y":8},{"x":11,"y":8},{"x":2,"y":9},{"x":8,"y":9},{"x":2,"y":10},{"x":3,"y":10},{"x":4,"y":10},{"x":5,"y":10},{"x":6,"y":10},{"x":9,"y":10},{"x":11,"y":10}],"sourceLength":100};
